<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>JSON Demo</title>
    <style>
        button {
            width: 12rem;
            color: orangered;
        }

        .tag {
            width: 4rem;
        }

        #post-code {
            width: 5rem;
        }

        pre {
            background-color: #eee;
            padding: 1rem;
            font-size: large;
        }

        th {
            text-align: left;
            padding-right: 1rem;
        }
    </style>
</head>
<body>
    <table>
        <tr>
            <th>Name</th>
            <td><input type="text" id="name" placeholder="First & Last Names"/></td>
        </tr>
        <tr>
            <th>Age</th>
            <td><input type="number" id="age" placeholder="Age"/></td>
        </tr>
        <tr>
            <th>Address</th>
            <td>
                <input type="text" id="street" placeholder="Street"/>
                <input type="text" id="post-code" placeholder="Post Code"/>
                <input type="text" id="city" placeholder="City"/>
            </td>
        </tr>
        <tr>
            <th>Tags</th>
            <td>
                <input type="text" class="tag">
                <input type="text" class="tag">
                <input type="text" class="tag">
                <input type="text" class="tag">
                <input type="text" class="tag">
                <input type="text" class="tag">
                <input type="text" class="tag">
            </td>
        </tr>
        <tr>
            <th></th>
            <td>
                <button type="button" id="to-json"> To JSON</button>
                <button type="button" id="clear"> Clear</button>
            </td>
        </tr>
    </table>
    <hr/>
    <h3>JSON Text</h3>
    <pre id="json"></pre>

    <script>
        document.getElementById('to-json').onclick = (ev) => {
            let data = {
                name: document.getElementById('name').value,
                age: document.getElementById('age').value,
                address: {
                    street: document.getElementById('street').value,
                    postCode: document.getElementById('post-code').value,
                    city: document.getElementById('city').value
                },
                tags: (el => {
                    let r = [];
                    for (let k = 0; k < el.length; ++k) if (el[k].value) r.push(el[k].value);
                    return r;
                })(document.getElementsByClassName('tag'))
            };
            document.getElementById("json").innerText = JSON.stringify(data);
        };

        document.getElementById('clear').onclick = (ev) => {
            let inputs = document.getElementsByTagName('input');
            for (let k = 0; k < inputs.length; ++k) inputs[k].value = '';
        };
    </script>
</body>
</html>